
#include <gtk-modules/globalmenu/globalmenu-locator.h>




static GlobalMenuGTKLocator* global_menu_gtk_locator_new (void);
static void global_menu_gtk_locator_instance_init (GlobalMenuGTKLocator * self);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);



static GlobalMenuGTKLocator* global_menu_gtk_locator_new (void) {
	GlobalMenuGTKLocator* self;
	self = g_slice_new0 (GlobalMenuGTKLocator);
	global_menu_gtk_locator_instance_init (self);
	return self;
}


GtkMenuItem* global_menu_gtk_locator_locate (GtkMenuBar* menubar, const char* path) {
	char** _tmp0;
	gint tokens_size;
	gint tokens_length1;
	char** tokens;
	GtkMenuShell* _tmp1;
	GtkMenuShell* shell;
	GtkMenuItem* _tmp13;
	g_return_val_if_fail (menubar != NULL, NULL);
	g_return_val_if_fail (path != NULL, NULL);
	_tmp0 = NULL;
	tokens = (_tmp0 = g_strsplit_set (path, "/", -1), tokens_length1 = -1, tokens_size = tokens_length1, _tmp0);
	tokens_length1 = (gint) g_strv_length (tokens);
	_tmp1 = NULL;
	shell = (_tmp1 = (GtkMenuShell*) menubar, (_tmp1 == NULL) ? NULL : g_object_ref (_tmp1));
	{
		gint i;
		/*
		weak string rev = tokens[0];
		FIXME: implement the revision */
		i = 1;
		for (; i < tokens_length1; i++) {
			const char* token;
			GtkMenuItem* item;
			GList* children;
			GtkMenuShell* _tmp11;
			GtkMenuShell* _tmp10;
			token = tokens[i];
			item = NULL;
			children = gtk_container_get_children ((GtkContainer*) shell);
			if (g_str_has_prefix (token, "W")) {
				gulong pointer;
				pointer = strtoul (g_utf8_offset_to_pointer (token, (glong) 1), NULL, 0);
				/*Widget Pointer*/
				{
					GList* child_collection;
					GList* child_it;
					child_collection = children;
					for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
						GtkWidget* child;
						child = (GtkWidget*) child_it->data;
						{
							if (((gulong) child) == pointer) {
								GtkMenuItem* _tmp4;
								GtkMenuItem* _tmp3;
								GtkWidget* _tmp2;
								_tmp4 = NULL;
								_tmp3 = NULL;
								_tmp2 = NULL;
								item = (_tmp4 = (_tmp3 = (_tmp2 = child, GTK_IS_MENU_ITEM (_tmp2) ? ((GtkMenuItem*) _tmp2) : NULL), (_tmp3 == NULL) ? NULL : g_object_ref (_tmp3)), (item == NULL) ? NULL : (item = (g_object_unref (item), NULL)), _tmp4);
								break;
							}
						}
					}
				}
			} else {
				gint position;
				/*assume it is an id*/
				position = atoi (token);
				{
					GList* child_collection;
					GList* child_it;
					child_collection = children;
					for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
						GtkWidget* child;
						child = (GtkWidget*) child_it->data;
						{
							if (GTK_IS_TEAROFF_MENU_ITEM (child)) {
								continue;
							}
							if (position == 0) {
								GtkMenuItem* _tmp7;
								GtkMenuItem* _tmp6;
								GtkWidget* _tmp5;
								_tmp7 = NULL;
								_tmp6 = NULL;
								_tmp5 = NULL;
								item = (_tmp7 = (_tmp6 = (_tmp5 = child, GTK_IS_MENU_ITEM (_tmp5) ? ((GtkMenuItem*) _tmp5) : NULL), (_tmp6 == NULL) ? NULL : g_object_ref (_tmp6)), (item == NULL) ? NULL : (item = (g_object_unref (item), NULL)), _tmp7);
								break;
							}
							position--;
						}
					}
				}
			}
			if (i == (tokens_length1 - 1)) {
				GtkMenuItem* _tmp8;
				_tmp8 = NULL;
				return (_tmp8 = item, (children == NULL) ? NULL : (children = (g_list_free (children), NULL)), tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL), (shell == NULL) ? NULL : (shell = (g_object_unref (shell), NULL)), _tmp8);
			}
			if (item == NULL) {
				GtkMenuItem* _tmp9;
				_tmp9 = NULL;
				return (_tmp9 = NULL, (item == NULL) ? NULL : (item = (g_object_unref (item), NULL)), (children == NULL) ? NULL : (children = (g_list_free (children), NULL)), tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL), (shell == NULL) ? NULL : (shell = (g_object_unref (shell), NULL)), _tmp9);
			}
			_tmp11 = NULL;
			_tmp10 = NULL;
			shell = (_tmp11 = (_tmp10 = (GtkMenuShell*) gtk_menu_item_get_submenu (item), (_tmp10 == NULL) ? NULL : g_object_ref (_tmp10)), (shell == NULL) ? NULL : (shell = (g_object_unref (shell), NULL)), _tmp11);
			if (shell == NULL) {
				GtkMenuItem* _tmp12;
				_tmp12 = NULL;
				return (_tmp12 = NULL, (item == NULL) ? NULL : (item = (g_object_unref (item), NULL)), (children == NULL) ? NULL : (children = (g_list_free (children), NULL)), tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL), (shell == NULL) ? NULL : (shell = (g_object_unref (shell), NULL)), _tmp12);
			}
			(item == NULL) ? NULL : (item = (g_object_unref (item), NULL));
			(children == NULL) ? NULL : (children = (g_list_free (children), NULL));
		}
	}
	_tmp13 = NULL;
	return (_tmp13 = NULL, tokens = (_vala_array_free (tokens, tokens_length1, (GDestroyNotify) g_free), NULL), (shell == NULL) ? NULL : (shell = (g_object_unref (shell), NULL)), _tmp13);
}


static void global_menu_gtk_locator_instance_init (GlobalMenuGTKLocator * self) {
}


void global_menu_gtk_locator_free (GlobalMenuGTKLocator* self) {
	g_slice_free (GlobalMenuGTKLocator, self);
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
	g_free (array);
}




