
#include <libgnomenu/globalmenu.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <libgnomenu/window.h>
#include <libgnomenu/parser.h>
#include <libgnomenu/interface-shell.h>
#include <libgnomenu/menuitem.h>
#include <libgnomenu/interface-item.h>




struct _GnomenuGlobalMenuPrivate {
	GnomenuWindow* current_window;
	GnomenuWindow* _root_gnomenu_window;
};

#define GNOMENU_GLOBAL_MENU_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GNOMENU_TYPE_GLOBAL_MENU, GnomenuGlobalMenuPrivate))
enum  {
	GNOMENU_GLOBAL_MENU_DUMMY_PROPERTY
};
static void gnomenu_global_menu_regrab_menu_bar_key (GnomenuGlobalMenu* self);
static void _gnomenu_global_menu_regrab_menu_bar_key_g_object_notify (GtkSettings* _sender, GParamSpec* pspec, gpointer self);
static void gnomenu_global_menu_attach_to_screen (GnomenuGlobalMenu* self, GdkScreen* screen);
static void gnomenu_global_menu_detach_from_screen (GnomenuGlobalMenu* self, GdkScreen* screen);
static void gnomenu_global_menu_real_screen_changed (GtkWidget* base, GdkScreen* previous_screen);
static void __lambda0 (GnomenuWindow* window, GnomenuGlobalMenu* self);
static void ___lambda0_gnomenu_window_menu_context_changed (GnomenuWindow* _sender, gpointer self);
static void gnomenu_global_menu_update (GnomenuGlobalMenu* self);
static void gnomenu_global_menu_ungrab_menu_bar_key (GnomenuGlobalMenu* self);
static void gnomenu_global_menu_grab_menu_bar_key (GnomenuGlobalMenu* self);
static void gnomenu_global_menu_get_accel_key (GnomenuGlobalMenu* self, guint* keyval, GdkModifierType* mods);
static void __lambda1 (GnomenuGlobalMenu* menubar, GnomenuMenuItem* item, GnomenuGlobalMenu* self);
static void ___lambda1_gnomenu_menu_bar_activate (GnomenuGlobalMenu* _sender, GnomenuMenuItem* item, gpointer self);
static gboolean __lambda2 (GnomenuGlobalMenu* t, const GdkEventKey* event, GnomenuGlobalMenu* self);
static gboolean ___lambda2_gtk_widget_key_press_event (GnomenuGlobalMenu* _sender, const GdkEventKey* event, gpointer self);
static GObject * gnomenu_global_menu_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static gpointer gnomenu_global_menu_parent_class = NULL;
static void gnomenu_global_menu_finalize (GObject* obj);



static void gnomenu_global_menu_regrab_menu_bar_key (GnomenuGlobalMenu* self) {
	g_return_if_fail (self != NULL);
	g_message ("globalmenu.vala:31: regrab menu_bar key");
	gnomenu_global_menu_ungrab_menu_bar_key (self);
	gnomenu_global_menu_grab_menu_bar_key (self);
}


static void _gnomenu_global_menu_regrab_menu_bar_key_g_object_notify (GtkSettings* _sender, GParamSpec* pspec, gpointer self) {
	gnomenu_global_menu_regrab_menu_bar_key (self);
}


static void gnomenu_global_menu_attach_to_screen (GnomenuGlobalMenu* self, GdkScreen* screen) {
	GnomenuWindow* _tmp0;
	GtkSettings* _tmp1;
	GtkSettings* settings;
	g_return_if_fail (self != NULL);
	g_return_if_fail (screen != NULL);
	_tmp0 = NULL;
	self->priv->_root_gnomenu_window = (_tmp0 = gnomenu_window_new (gtk_widget_get_root_window ((GtkWidget*) self)), (self->priv->_root_gnomenu_window == NULL) ? NULL : (self->priv->_root_gnomenu_window = (g_object_unref (self->priv->_root_gnomenu_window), NULL)), _tmp0);
	gnomenu_window_set_key_widget (self->priv->_root_gnomenu_window, (GtkWidget*) self);
	gnomenu_global_menu_grab_menu_bar_key (self);
	_tmp1 = NULL;
	settings = (_tmp1 = gtk_widget_get_settings ((GtkWidget*) self), (_tmp1 == NULL) ? NULL : g_object_ref (_tmp1));
	g_signal_connect_object ((GObject*) settings, "notify::gtk-menu-bar-accel", (GCallback) _gnomenu_global_menu_regrab_menu_bar_key_g_object_notify, self, 0);
	(settings == NULL) ? NULL : (settings = (g_object_unref (settings), NULL));
}


static void gnomenu_global_menu_detach_from_screen (GnomenuGlobalMenu* self, GdkScreen* screen) {
	GtkSettings* _tmp0;
	GtkSettings* settings;
	GQuark _tmp2;
	guint _tmp1;
	GnomenuWindow* _tmp3;
	g_return_if_fail (self != NULL);
	g_return_if_fail (screen != NULL);
	if (self->priv->_root_gnomenu_window != NULL) {
		gnomenu_global_menu_ungrab_menu_bar_key (self);
	}
	_tmp0 = NULL;
	settings = (_tmp0 = gtk_widget_get_settings ((GtkWidget*) self), (_tmp0 == NULL) ? NULL : g_object_ref (_tmp0));
	g_signal_handlers_disconnect_matched ((GObject*) settings, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, (g_signal_parse_name ("notify::gtk-menu-bar-accel", G_TYPE_OBJECT, &_tmp1, &_tmp2, FALSE), _tmp1), 0, NULL, (GCallback) _gnomenu_global_menu_regrab_menu_bar_key_g_object_notify, self);
	_tmp3 = NULL;
	self->priv->_root_gnomenu_window = (_tmp3 = NULL, (self->priv->_root_gnomenu_window == NULL) ? NULL : (self->priv->_root_gnomenu_window = (g_object_unref (self->priv->_root_gnomenu_window), NULL)), _tmp3);
	(settings == NULL) ? NULL : (settings = (g_object_unref (settings), NULL));
}


static void gnomenu_global_menu_real_screen_changed (GtkWidget* base, GdkScreen* previous_screen) {
	GnomenuGlobalMenu * self;
	GdkScreen* _tmp0;
	GdkScreen* screen;
	self = (GnomenuGlobalMenu*) base;
	_tmp0 = NULL;
	screen = (_tmp0 = gtk_widget_get_screen ((GtkWidget*) self), (_tmp0 == NULL) ? NULL : g_object_ref (_tmp0));
	if (previous_screen != screen) {
		if (previous_screen != NULL) {
			gnomenu_global_menu_detach_from_screen (self, previous_screen);
		}
		if (screen != NULL) {
			gnomenu_global_menu_attach_to_screen (self, screen);
		}
	}
	(screen == NULL) ? NULL : (screen = (g_object_unref (screen), NULL));
}


static void __lambda0 (GnomenuWindow* window, GnomenuGlobalMenu* self) {
	g_return_if_fail (window != NULL);
	gnomenu_global_menu_update (self);
}


static void ___lambda0_gnomenu_window_menu_context_changed (GnomenuWindow* _sender, gpointer self) {
	__lambda0 (_sender, self);
}


void gnomenu_global_menu_switch_to (GnomenuGlobalMenu* self, gulong xid) {
	GnomenuWindow* _tmp0;
	g_return_if_fail (self != NULL);
	_tmp0 = NULL;
	self->priv->current_window = (_tmp0 = gnomenu_window_foreign_new (xid), (self->priv->current_window == NULL) ? NULL : (self->priv->current_window = (g_object_unref (self->priv->current_window), NULL)), _tmp0);
	if (self->priv->current_window != NULL) {
		g_signal_connect (self->priv->current_window, "menu-context-changed", (GCallback) ___lambda0_gnomenu_window_menu_context_changed, self);
		gnomenu_global_menu_update (self);
	}
}


static void gnomenu_global_menu_update (GnomenuGlobalMenu* self) {
	GError * inner_error;
	const char* context;
	g_return_if_fail (self != NULL);
	inner_error = NULL;
	context = gnomenu_window_get_menu_context (self->priv->current_window);
	if (context != NULL) {
		{
			gnomenu_parser_parse ((GnomenuShell*) self, context, &inner_error);
			if (inner_error != NULL) {
				goto __catch2_g_error;
				goto __finally2;
			}
		}
		goto __finally2;
		__catch2_g_error:
		{
			GError * e;
			e = inner_error;
			inner_error = NULL;
			{
				g_warning ("globalmenu.vala:74: %s", e->message);
				(e == NULL) ? NULL : (e = (g_error_free (e), NULL));
			}
		}
		__finally2:
		if (inner_error != NULL) {
			g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, inner_error->message);
			g_clear_error (&inner_error);
			return;
		}
		gtk_widget_show ((GtkWidget*) self);
		return;
	}
	gtk_widget_hide ((GtkWidget*) self);
}


static void gnomenu_global_menu_ungrab_menu_bar_key (GnomenuGlobalMenu* self) {
	gint keyval;
	GdkModifierType mods;
	g_return_if_fail (self != NULL);
	keyval = (gint) g_object_get_data ((GObject*) self->priv->_root_gnomenu_window, "menu-bar-keyval");
	mods = (GdkModifierType) g_object_get_data ((GObject*) self->priv->_root_gnomenu_window, "menu-bar-keymods");
	gnomenu_window_ungrab_key (self->priv->_root_gnomenu_window, (guint) keyval, mods);
	g_object_set_data ((GObject*) self->priv->_root_gnomenu_window, "menu-bar-keyval", NULL);
	g_object_set_data ((GObject*) self->priv->_root_gnomenu_window, "menu-bar-keymods", NULL);
}


static void gnomenu_global_menu_grab_menu_bar_key (GnomenuGlobalMenu* self) {
	gint keyval;
	GdkModifierType mods;
	g_return_if_fail (self != NULL);
	/*FIXME: listen to changes in GTK_SETTINGS.*/
	keyval = 0;
	mods = 0;
	gnomenu_global_menu_get_accel_key (self, &keyval, &mods);
	gnomenu_window_grab_key (self->priv->_root_gnomenu_window, (guint) keyval, mods);
	g_object_set_data ((GObject*) self->priv->_root_gnomenu_window, "menu-bar-keyval", (void*) keyval);
	g_object_set_data ((GObject*) self->priv->_root_gnomenu_window, "menu-bar-keymods", (void*) mods);
}


/**
 * return the accelerator key combination for invoking menu bars
 * in GTK Settings. It is usually F10.
 */
static void gnomenu_global_menu_get_accel_key (GnomenuGlobalMenu* self, guint* keyval, GdkModifierType* mods) {
	GtkSettings* _tmp0;
	GtkSettings* settings;
	char* accel;
	g_return_if_fail (self != NULL);
	_tmp0 = NULL;
	settings = (_tmp0 = gtk_widget_get_settings ((GtkWidget*) self), (_tmp0 == NULL) ? NULL : g_object_ref (_tmp0));
	accel = NULL;
	g_object_get ((GObject*) settings, "gtk_menu_bar_accel", &accel, NULL, NULL);
	if (accel != NULL) {
		gtk_accelerator_parse (accel, &(*keyval), &(*mods));
	}
	(settings == NULL) ? NULL : (settings = (g_object_unref (settings), NULL));
	accel = (g_free (accel), NULL);
}


GnomenuGlobalMenu* gnomenu_global_menu_construct (GType object_type) {
	GnomenuGlobalMenu * self;
	self = (GnomenuGlobalMenu*) gnomenu_menu_bar_construct (object_type);
	return self;
}


GnomenuGlobalMenu* gnomenu_global_menu_new (void) {
	return gnomenu_global_menu_construct (GNOMENU_TYPE_GLOBAL_MENU);
}


static void __lambda1 (GnomenuGlobalMenu* menubar, GnomenuMenuItem* item, GnomenuGlobalMenu* self) {
	g_return_if_fail (menubar != NULL);
	g_return_if_fail (item != NULL);
	if (self->priv->current_window != NULL) {
		char* _tmp0;
		_tmp0 = NULL;
		gnomenu_window_emit_menu_event (self->priv->current_window, _tmp0 = gnomenu_item_get_item_path ((GnomenuItem*) item));
		_tmp0 = (g_free (_tmp0), NULL);
	}
}


static void ___lambda1_gnomenu_menu_bar_activate (GnomenuGlobalMenu* _sender, GnomenuMenuItem* item, gpointer self) {
	__lambda1 (_sender, item, self);
}


static gboolean __lambda2 (GnomenuGlobalMenu* t, const GdkEventKey* event, GnomenuGlobalMenu* self) {
	guint keyval;
	GdkModifierType mods;
	gboolean _tmp0;
	g_return_val_if_fail (t != NULL, FALSE);
	keyval = 0U;
	mods = 0;
	gnomenu_global_menu_get_accel_key (self, &keyval, &mods);
	_tmp0 = FALSE;
	if ((*event).keyval == keyval) {
		_tmp0 = ((*event).state & gtk_accelerator_get_default_mod_mask ()) == (mods & gtk_accelerator_get_default_mod_mask ());
	} else {
		_tmp0 = FALSE;
	}
	if (_tmp0) {
		GtkWidget* _tmp1;
		GtkWidget* toplevel;
		gboolean _tmp3;
		/* We chain up to the toplevel key_press_event,
		 * which is listened by all the menubars within
		 * the applet*/
		_tmp1 = NULL;
		toplevel = (_tmp1 = gtk_widget_get_toplevel ((GtkWidget*) self), (_tmp1 == NULL) ? NULL : g_object_ref (_tmp1));
		if (toplevel != NULL) {
			gboolean _tmp2;
			g_signal_emit_by_name (toplevel, "key-press-event", &(*event), &_tmp2);
			_tmp2;
		}
		return (_tmp3 = FALSE, (toplevel == NULL) ? NULL : (toplevel = (g_object_unref (toplevel), NULL)), _tmp3);
	}
	return TRUE;
}


static gboolean ___lambda2_gtk_widget_key_press_event (GnomenuGlobalMenu* _sender, const GdkEventKey* event, gpointer self) {
	return __lambda2 (_sender, event, self);
}


static GObject * gnomenu_global_menu_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GnomenuGlobalMenuClass * klass;
	GObjectClass * parent_class;
	GnomenuGlobalMenu * self;
	klass = GNOMENU_GLOBAL_MENU_CLASS (g_type_class_peek (GNOMENU_TYPE_GLOBAL_MENU));
	parent_class = G_OBJECT_CLASS (g_type_class_peek_parent (klass));
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = GNOMENU_GLOBAL_MENU (obj);
	{
		g_signal_connect ((GnomenuMenuBar*) self, "activate", (GCallback) ___lambda1_gnomenu_menu_bar_activate, self);
		g_signal_connect ((GtkWidget*) self, "key-press-event", (GCallback) ___lambda2_gtk_widget_key_press_event, self);
	}
	return obj;
}


static void gnomenu_global_menu_class_init (GnomenuGlobalMenuClass * klass) {
	gnomenu_global_menu_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GnomenuGlobalMenuPrivate));
	G_OBJECT_CLASS (klass)->constructor = gnomenu_global_menu_constructor;
	G_OBJECT_CLASS (klass)->finalize = gnomenu_global_menu_finalize;
	GTK_WIDGET_CLASS (klass)->screen_changed = gnomenu_global_menu_real_screen_changed;
}


static void gnomenu_global_menu_instance_init (GnomenuGlobalMenu * self) {
	self->priv = GNOMENU_GLOBAL_MENU_GET_PRIVATE (self);
}


static void gnomenu_global_menu_finalize (GObject* obj) {
	GnomenuGlobalMenu * self;
	self = GNOMENU_GLOBAL_MENU (obj);
	(self->priv->current_window == NULL) ? NULL : (self->priv->current_window = (g_object_unref (self->priv->current_window), NULL));
	(self->priv->_root_gnomenu_window == NULL) ? NULL : (self->priv->_root_gnomenu_window = (g_object_unref (self->priv->_root_gnomenu_window), NULL));
	G_OBJECT_CLASS (gnomenu_global_menu_parent_class)->finalize (obj);
}


GType gnomenu_global_menu_get_type (void) {
	static GType gnomenu_global_menu_type_id = 0;
	if (gnomenu_global_menu_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (GnomenuGlobalMenuClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gnomenu_global_menu_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GnomenuGlobalMenu), 0, (GInstanceInitFunc) gnomenu_global_menu_instance_init, NULL };
		gnomenu_global_menu_type_id = g_type_register_static (GNOMENU_TYPE_MENU_BAR, "GnomenuGlobalMenu", &g_define_type_info, 0);
	}
	return gnomenu_global_menu_type_id;
}




