
#include "test-parser.h"
#include <libgnomenu/menubar.h>
#include <libgnomenu/parser.h>
#include <libgnomenu/interface-shell.h>
#include <libgnomenu/serializer.h>
#include <gtk/gtk.h>
#include <glib/gstdio.h>
#include <configmake.h>




struct _GnomenuTestParserPrivate {
	GnomenuMenuBar* shell;
	char* test1;
	char* test2;
};

#define GNOMENU_TEST_PARSER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GNOMENU_TYPE_TEST_PARSER, GnomenuTestParserPrivate))
enum  {
	GNOMENU_TEST_PARSER_DUMMY_PROPERTY
};
static void __lambda0 (GnomenuTestParser* self);
static void ___lambda0_gdata_test_func (gpointer self);
static void _gtk_main_quit_gtk_object_destroy (GtkWindow* _sender, gpointer self);
static void __lambda1 (GnomenuTestParser* self);
static void ___lambda1_gdata_test_func (gpointer self);
static void __lambda2 (GnomenuTestParser* self);
static void ___lambda2_gdata_test_func (gpointer self);
static void __lambda3 (GnomenuTestParser* self);
static void ___lambda3_gdata_test_func (gpointer self);
static GnomenuTestParser* gnomenu_test_parser_construct (GType object_type);
static GnomenuTestParser* gnomenu_test_parser_new (void);
static gpointer gnomenu_test_parser_parent_class = NULL;
static void gnomenu_test_parser_finalize (GObject* obj);
static int _vala_strcmp0 (const char * str1, const char * str2);



static void __lambda0 (GnomenuTestParser* self) {
	GError * inner_error;
	GnomenuMenuBar* _tmp0;
	char* _tmp1;
	char* _tmp2;
	inner_error = NULL;
	_tmp0 = NULL;
	self->priv->shell = (_tmp0 = g_object_ref_sink (gnomenu_menu_bar_new ()), (self->priv->shell == NULL) ? NULL : (self->priv->shell = (g_object_unref (self->priv->shell), NULL)), _tmp0);
	gnomenu_parser_parse ((GnomenuShell*) self->priv->shell, self->priv->test1, &inner_error);
	if (inner_error != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, inner_error->message);
		g_clear_error (&inner_error);
		return;
	}
	_tmp1 = NULL;
	g_test_message ("%s == %s", self->priv->test1, _tmp1 = gnomenu_serializer_to_string ((GObject*) self->priv->shell, FALSE));
	_tmp1 = (g_free (_tmp1), NULL);
	_tmp2 = NULL;
	g_assert (_vala_strcmp0 (self->priv->test1, _tmp2 = gnomenu_serializer_to_string ((GObject*) self->priv->shell, FALSE)) == 0);
	_tmp2 = (g_free (_tmp2), NULL);
}


static void ___lambda0_gdata_test_func (gpointer self) {
	__lambda0 (self);
}


static void _gtk_main_quit_gtk_object_destroy (GtkWindow* _sender, gpointer self) {
	gtk_main_quit ();
}


static void __lambda1 (GnomenuTestParser* self) {
	GError * inner_error;
	GnomenuMenuBar* _tmp0;
	char* _tmp1;
	GtkWindow* window;
	inner_error = NULL;
	_tmp0 = NULL;
	self->priv->shell = (_tmp0 = g_object_ref_sink (gnomenu_menu_bar_new ()), (self->priv->shell == NULL) ? NULL : (self->priv->shell = (g_object_unref (self->priv->shell), NULL)), _tmp0);
	gnomenu_parser_parse ((GnomenuShell*) self->priv->shell, self->priv->test2, &inner_error);
	if (inner_error != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, inner_error->message);
		g_clear_error (&inner_error);
		return;
	}
	_tmp1 = NULL;
	g_test_message ("%s", _tmp1 = gnomenu_serializer_to_string ((GObject*) self->priv->shell, TRUE));
	_tmp1 = (g_free (_tmp1), NULL);
	window = g_object_ref_sink ((GtkWindow*) gtk_window_new (GTK_WINDOW_TOPLEVEL));
	gtk_container_add ((GtkContainer*) window, (GtkWidget*) self->priv->shell);
	g_object_set ((GtkWidget*) self->priv->shell, "visible", TRUE, NULL);
	g_signal_connect ((GtkObject*) window, "destroy", (GCallback) _gtk_main_quit_gtk_object_destroy, NULL);
	gtk_widget_show_all ((GtkWidget*) window);
	gtk_main ();
	(window == NULL) ? NULL : (window = (g_object_unref (window), NULL));
}


static void ___lambda1_gdata_test_func (gpointer self) {
	__lambda1 (self);
}


static void __lambda2 (GnomenuTestParser* self) {
	GError * inner_error;
	GnomenuMenuBar* _tmp0;
	char* _tmp1;
	char* _tmp2;
	inner_error = NULL;
	_tmp0 = NULL;
	self->priv->shell = (_tmp0 = g_object_ref_sink (gnomenu_menu_bar_new ()), (self->priv->shell == NULL) ? NULL : (self->priv->shell = (g_object_unref (self->priv->shell), NULL)), _tmp0);
	gnomenu_parser_parse ((GnomenuShell*) self->priv->shell, self->priv->test2, &inner_error);
	if (inner_error != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, inner_error->message);
		g_clear_error (&inner_error);
		return;
	}
	gnomenu_parser_parse ((GnomenuShell*) self->priv->shell, self->priv->test1, &inner_error);
	if (inner_error != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, inner_error->message);
		g_clear_error (&inner_error);
		return;
	}
	_tmp1 = NULL;
	g_test_message ("%s == %s", self->priv->test1, _tmp1 = gnomenu_serializer_to_string ((GObject*) self->priv->shell, FALSE));
	_tmp1 = (g_free (_tmp1), NULL);
	_tmp2 = NULL;
	g_assert (_vala_strcmp0 (self->priv->test1, _tmp2 = gnomenu_serializer_to_string ((GObject*) self->priv->shell, FALSE)) == 0);
	_tmp2 = (g_free (_tmp2), NULL);
}


static void ___lambda2_gdata_test_func (gpointer self) {
	__lambda2 (self);
}


static void __lambda3 (GnomenuTestParser* self) {
	GError * inner_error;
	GnomenuMenuBar* _tmp0;
	char* test3;
	char* test4;
	char* _tmp3;
	gboolean _tmp2;
	char* _tmp1;
	char* _tmp6;
	gboolean _tmp5;
	char* _tmp4;
	char* _tmp7;
	GtkWindow* window;
	inner_error = NULL;
	_tmp0 = NULL;
	self->priv->shell = (_tmp0 = g_object_ref_sink (gnomenu_menu_bar_new ()), (self->priv->shell == NULL) ? NULL : (self->priv->shell = (g_object_unref (self->priv->shell), NULL)), _tmp0);
	test3 = NULL;
	test4 = NULL;
	_tmp3 = NULL;
	_tmp1 = NULL;
	_tmp2 = g_file_get_contents (ABSTOPSRCDIR "/libgnomenu/tests/evo-nolabel.xml", &_tmp1, NULL, &inner_error);
	test3 = (_tmp3 = _tmp1, test3 = (g_free (test3), NULL), _tmp3);
	_tmp2;
	if (inner_error != NULL) {
		test3 = (g_free (test3), NULL);
		test4 = (g_free (test4), NULL);
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, inner_error->message);
		g_clear_error (&inner_error);
		return;
	}
	_tmp6 = NULL;
	_tmp4 = NULL;
	_tmp5 = g_file_get_contents (ABSTOPSRCDIR "/libgnomenu/tests/evo.xml", &_tmp4, NULL, &inner_error);
	test4 = (_tmp6 = _tmp4, test4 = (g_free (test4), NULL), _tmp6);
	_tmp5;
	if (inner_error != NULL) {
		test3 = (g_free (test3), NULL);
		test4 = (g_free (test4), NULL);
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, inner_error->message);
		g_clear_error (&inner_error);
		return;
	}
	gnomenu_parser_parse ((GnomenuShell*) self->priv->shell, test3, &inner_error);
	if (inner_error != NULL) {
		test3 = (g_free (test3), NULL);
		test4 = (g_free (test4), NULL);
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, inner_error->message);
		g_clear_error (&inner_error);
		return;
	}
	gnomenu_parser_parse ((GnomenuShell*) self->priv->shell, test3, &inner_error);
	if (inner_error != NULL) {
		test3 = (g_free (test3), NULL);
		test4 = (g_free (test4), NULL);
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, inner_error->message);
		g_clear_error (&inner_error);
		return;
	}
	gnomenu_parser_parse ((GnomenuShell*) self->priv->shell, test3, &inner_error);
	if (inner_error != NULL) {
		test3 = (g_free (test3), NULL);
		test4 = (g_free (test4), NULL);
		g_critical ("file %s: line %d: uncaught error: %s", __FILE__, __LINE__, inner_error->message);
		g_clear_error (&inner_error);
		return;
	}
	/*Parser.parse(shell, test4);*/
	_tmp7 = NULL;
	g_test_message ("%s", _tmp7 = gnomenu_serializer_to_string ((GObject*) self->priv->shell, TRUE));
	_tmp7 = (g_free (_tmp7), NULL);
	window = g_object_ref_sink ((GtkWindow*) gtk_window_new (GTK_WINDOW_TOPLEVEL));
	gtk_container_add ((GtkContainer*) window, (GtkWidget*) self->priv->shell);
	g_object_set ((GtkWidget*) self->priv->shell, "visible", TRUE, NULL);
	g_signal_connect ((GtkObject*) window, "destroy", (GCallback) _gtk_main_quit_gtk_object_destroy, NULL);
	gtk_widget_show_all ((GtkWidget*) window);
	gtk_main ();
	test3 = (g_free (test3), NULL);
	test4 = (g_free (test4), NULL);
	(window == NULL) ? NULL : (window = (g_object_unref (window), NULL));
}


static void ___lambda3_gdata_test_func (gpointer self) {
	__lambda3 (self);
}


static GnomenuTestParser* gnomenu_test_parser_construct (GType object_type) {
	GnomenuTestParser * self;
	self = (GnomenuTestParser*) test_man_construct (object_type, "/Parser");
	test_man_add ((TestMan*) self, "test1", ___lambda0_gdata_test_func, self);
	test_man_add ((TestMan*) self, "test2/Show", ___lambda1_gdata_test_func, self);
	test_man_add ((TestMan*) self, "Reuse", ___lambda2_gdata_test_func, self);
	test_man_add ((TestMan*) self, "Evolution", ___lambda3_gdata_test_func, self);
	return self;
}


static GnomenuTestParser* gnomenu_test_parser_new (void) {
	return gnomenu_test_parser_construct (GNOMENU_TYPE_TEST_PARSER);
}


static void gnomenu_test_parser_class_init (GnomenuTestParserClass * klass) {
	gnomenu_test_parser_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GnomenuTestParserPrivate));
	G_OBJECT_CLASS (klass)->finalize = gnomenu_test_parser_finalize;
}


static void gnomenu_test_parser_instance_init (GnomenuTestParser * self) {
	self->priv = GNOMENU_TEST_PARSER_GET_PRIVATE (self);
	self->priv->test1 = g_strdup ("<menu><item><menu><item/></menu></item><item/></menu>");
	self->priv->test2 = g_strdup ("\n<menu>\n\t<item id=\"File\" font=\"Serif Bold 20\" accel=\"Control+L\">\n\t\t<menu>\n\t\t\t<item id=\"New\" label=\"New\" type=\"c\" state=\"toggled\"/>\n\t\t\t<item id=\"Open\" label=\"Open\" type=\"r\" state=\"untoggled\"/>\n\t\t\t<item id=\"Close\" label=\"Close\" type=\"r\" accel=\"Control+Q\"/>\n\t\t</menu>\n\t</item>\n\t<item id=\"Edit\">\n\t\t<menu>\n\t\t\t<item id=\"Copy\" type=\"image\" icon=\"wnck-stock-delete\"/>\n\t\t\t<item id=\"Paste\"/>\n\t\t</menu>\n\t</item>\n\t<item id=\"Help\">\n\t\t<menu>\n\t\t\t<item id=\"About\"/>\n\t\t</menu>\n\t</item>\n\t<item type=\"a\"/>\n</menu>\n");
}


static void gnomenu_test_parser_finalize (GObject* obj) {
	GnomenuTestParser * self;
	self = GNOMENU_TEST_PARSER (obj);
	(self->priv->shell == NULL) ? NULL : (self->priv->shell = (g_object_unref (self->priv->shell), NULL));
	self->priv->test1 = (g_free (self->priv->test1), NULL);
	self->priv->test2 = (g_free (self->priv->test2), NULL);
	G_OBJECT_CLASS (gnomenu_test_parser_parent_class)->finalize (obj);
}


GType gnomenu_test_parser_get_type (void) {
	static GType gnomenu_test_parser_type_id = 0;
	if (gnomenu_test_parser_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (GnomenuTestParserClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gnomenu_test_parser_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GnomenuTestParser), 0, (GInstanceInitFunc) gnomenu_test_parser_instance_init, NULL };
		gnomenu_test_parser_type_id = g_type_register_static (TYPE_TEST_MAN, "GnomenuTestParser", &g_define_type_info, 0);
	}
	return gnomenu_test_parser_type_id;
}


gint gnomenu_main (char** args, int args_length1) {
	GnomenuTestParser* t;
	gint _tmp0;
	g_test_init (&args_length1, &args, NULL);
	gtk_init (&args_length1, &args);
	t = gnomenu_test_parser_new ();
	test_man_run ((TestMan*) t);
	return (_tmp0 = 0, (t == NULL) ? NULL : (t = (g_object_unref (t), NULL)), _tmp0);
}


int main (int argc, char ** argv) {
	g_type_init ();
	return gnomenu_main (argv, argc);
}


static int _vala_strcmp0 (const char * str1, const char * str2) {
	if (str1 == NULL) {
		return -(str1 != str2);
	}
	if (str2 == NULL) {
		return str1 != str2;
	}
	return strcmp (str1, str2);
}




