
#include "test-window.h"
#include <libgnomenu/window.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>




struct _GnomenuTestWindowPrivate {
	GnomenuWindow* test_window;
};

#define GNOMENU_TEST_WINDOW_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GNOMENU_TYPE_TEST_WINDOW, GnomenuTestWindowPrivate))
enum  {
	GNOMENU_TEST_WINDOW_DUMMY_PROPERTY
};
static gboolean __lambda1 (GtkWindow* d, const GdkEventKey* e, GnomenuTestWindow* self);
static gboolean ___lambda1_gtk_widget_key_press_event (GtkWindow* _sender, const GdkEventKey* event, gpointer self);
static void __lambda2 (GnomenuWindow* n, const char* e, GnomenuTestWindow* self);
static void ___lambda2_gnomenu_window_property_notify_event (GnomenuWindow* _sender, const char* name, gpointer self);
static void __lambda0 (GnomenuTestWindow* self);
static void ___lambda0_gdata_test_func (gpointer self);
static GnomenuTestWindow* gnomenu_test_window_construct (GType object_type);
static GnomenuTestWindow* gnomenu_test_window_new (void);
static gpointer gnomenu_test_window_parent_class = NULL;
static void gnomenu_test_window_finalize (GObject* obj);



static gboolean __lambda1 (GtkWindow* d, const GdkEventKey* e, GnomenuTestWindow* self) {
	g_return_val_if_fail (d != NULL, FALSE);
	g_message ("test-window.vala:20: key press event");
}


static gboolean ___lambda1_gtk_widget_key_press_event (GtkWindow* _sender, const GdkEventKey* event, gpointer self) {
	return __lambda1 (_sender, event, self);
}


static void __lambda2 (GnomenuWindow* n, const char* e, GnomenuTestWindow* self) {
	g_return_if_fail (n != NULL);
	g_return_if_fail (e != NULL);
	g_message ("test-window.vala:23: property event: %s", e);
}


static void ___lambda2_gnomenu_window_property_notify_event (GnomenuWindow* _sender, const char* name, gpointer self) {
	__lambda2 (_sender, name, self);
}


static void __lambda0 (GnomenuTestWindow* self) {
	GtkLabel* _tmp0;
	GtkWindow* dup;
	GnomenuWindow* new_win;
	_tmp0 = NULL;
	gtk_container_add ((GtkContainer*) ((TestMan*) self)->window, (GtkWidget*) (_tmp0 = g_object_ref_sink ((GtkLabel*) gtk_label_new ("Expecting a lot of property notify events"))));
	(_tmp0 == NULL) ? NULL : (_tmp0 = (g_object_unref (_tmp0), NULL));
	gtk_widget_show_all ((GtkWidget*) ((TestMan*) self)->window);
	dup = g_object_ref_sink ((GtkWindow*) gtk_window_new (GTK_WINDOW_TOPLEVEL));
	gtk_widget_show_all ((GtkWidget*) dup);
	new_win = gnomenu_window_new (((GtkWidget*) ((TestMan*) self)->window)->window);
	gnomenu_window_set_key_widget (new_win, (GtkWidget*) dup);
	g_signal_connect ((GtkWidget*) dup, "key-press-event", (GCallback) ___lambda1_gtk_widget_key_press_event, self);
	g_signal_connect (new_win, "property-notify-event", (GCallback) ___lambda2_gnomenu_window_property_notify_event, self);
	gtk_main ();
	(dup == NULL) ? NULL : (dup = (g_object_unref (dup), NULL));
	(new_win == NULL) ? NULL : (new_win = (g_object_unref (new_win), NULL));
}


static void ___lambda0_gdata_test_func (gpointer self) {
	__lambda0 (self);
}


static GnomenuTestWindow* gnomenu_test_window_construct (GType object_type) {
	GnomenuTestWindow * self;
	self = (GnomenuTestWindow*) test_man_construct (object_type, "/Window");
	test_man_add ((TestMan*) self, "newwindow", ___lambda0_gdata_test_func, self);
	return self;
}


static GnomenuTestWindow* gnomenu_test_window_new (void) {
	return gnomenu_test_window_construct (GNOMENU_TYPE_TEST_WINDOW);
}


gint gnomenu_test_window_main (char** args, int args_length1) {
	GnomenuTestWindow* t;
	gint _tmp0;
	g_test_init (&args_length1, &args, NULL);
	gtk_init (&args_length1, &args);
	t = gnomenu_test_window_new ();
	test_man_run ((TestMan*) t);
	return (_tmp0 = 0, (t == NULL) ? NULL : (t = (g_object_unref (t), NULL)), _tmp0);
}


int main (int argc, char ** argv) {
	g_type_init ();
	return gnomenu_test_window_main (argv, argc);
}


static void gnomenu_test_window_class_init (GnomenuTestWindowClass * klass) {
	gnomenu_test_window_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GnomenuTestWindowPrivate));
	G_OBJECT_CLASS (klass)->finalize = gnomenu_test_window_finalize;
}


static void gnomenu_test_window_instance_init (GnomenuTestWindow * self) {
	self->priv = GNOMENU_TEST_WINDOW_GET_PRIVATE (self);
}


static void gnomenu_test_window_finalize (GObject* obj) {
	GnomenuTestWindow * self;
	self = GNOMENU_TEST_WINDOW (obj);
	(self->priv->test_window == NULL) ? NULL : (self->priv->test_window = (g_object_unref (self->priv->test_window), NULL));
	G_OBJECT_CLASS (gnomenu_test_window_parent_class)->finalize (obj);
}


GType gnomenu_test_window_get_type (void) {
	static GType gnomenu_test_window_type_id = 0;
	if (gnomenu_test_window_type_id == 0) {
		static const GTypeInfo g_define_type_info = { sizeof (GnomenuTestWindowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gnomenu_test_window_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GnomenuTestWindow), 0, (GInstanceInitFunc) gnomenu_test_window_instance_init, NULL };
		gnomenu_test_window_type_id = g_type_register_static (TYPE_TEST_MAN, "GnomenuTestWindow", &g_define_type_info, 0);
	}
	return gnomenu_test_window_type_id;
}




